; Change List

CHANGELIST = 50

ClearChangeList:
 ld hl,ChangeList
 ld de,3
 ld bc,(CHANGELIST<<8)+255
ClearChangeListL:
 ld (hl),c
 add hl,de
 djnz ClearChangeListL
 ret

ChangeListFixMap:
 ld a,(CurrMap)
 ld c,a
 ld hl,ChangeList
 ld b,CHANGELIST
 ld d,0
ChangeListFixMapList
 ld a,(hl)
 inc hl
 cp c
 jr nz,ChangeListFixMapDone
 push hl
 ld e,(hl)
 inc hl
 ld a,(hl)
 ld hl,Map
 add hl,de
 ld (hl),a
 pop hl
ChangeListFixMapDone:
 inc hl
 inc hl
 djnz ChangeListFixMapList
 ret

; a = tile, b = map, c = offset
AddToChangeList:
 ld (_@AddToChangeListFoundTile),a
 ld a,b
 ld (_@AddToChangeListFoundMap),a
 ld a,c
 ld (_@AddToChangeListFoundOffset),a
 ld hl,ChangeList
 ld bc,(CHANGELIST<<8)+255
 ld de,3
AddToChangeListL:
 ld a,(hl)
 cp c
 jr z,AddToChangeListFound
 add hl,de
 djnz AddToChangeListL
 ret 
AddToChangeListFound:
 ld a,0
_@AddToChangeListFoundMap =$-1
 ld (hl),a
 inc hl
 ld a,0
_@AddToChangeListFoundOffset =$-1
 ld (hl),a
 inc hl
 ld a,0
_@AddToChangeListFoundTile =$-1
 ld (hl),a
 jr ChangeListFixMap

.end
